poj 2513 Colored Sticks 并查集 字典树 欧拉回路判断

点击打开链接题目链接

Colored Sticks

Time Limit: 5000MS   Memory Limit: 128000K
Total Submissions: 30273   Accepted: 8002

Description

You are given a bunch of wooden sticks. Each endpoint of each stick is colored with some color. Is it possible to align the sticks in a straight line such that the colors of the endpoints that touch are of the same color?

Input

Input is a sequence of lines, each line contains two words, separated by spaces, giving the colors of the endpoints of one stick. A word is a sequence of lowercase letters no longer than 10 characters. There is no more than 250000 sticks.

Output

If the sticks can be aligned in the desired way, output a single line saying Possible, otherwise output Impossible.

Sample Input

blue red
red violet
cyan blue
blue magenta
magenta cyan

Sample Output

Possible

给出一根棍子两端颜色 颜色一样的可以接在一起

问所有的棍子最后能否接到一起

#include<cstdio>
#include<cstring>
#include<iostream>
#include<cstdlib>
#include<algorithm>
using namespace std;
struct node
{
    int next[26];
    int id;
}trie[250010];
int head;
int father[25001    0];
int du[250010];
int ids=1;
int tree_add(char *str)
{
    int s=0;
    int len=strlen(str);
    int i;
    int w;
    for(i=0;i<len;i++)
    {
        w=str[i]-'a';
        if(trie[s].next[w]==-1)
        {
            trie[s].next[w]=++head;
        }
        s=trie[s].next[w];
    }
    if(trie[s].id==0)
    {
        trie[s].id=ids++;
        return trie[s].id;
    }
    else
        return trie[s].id;
}
int find(int x)
{
    if(x==father[x])
        return x;
    int t=father[x];
    father[x]=find(father[x]);
    return father[x];
}
int main()
{
    char str1[21];
    char str2[11];
    int i;
    int a,b;
    head=0;
    int j;
    for(i=0;i<=250010;i++)
    {
        trie[i].id=0;
        for(j=0;j<26;j++)
        {
            trie[i].next[j]=-1;
        }
        father[i]=i;
        du[i]=0;
    }
    while(gets(str1)!=NULL&&strcmp(str1,"")!=0)
    {
        for(i=0;str1[i]!='\0';i++)
        {
            if(str1[i-1]==' '&&str1[i]!=' ')
            {
                strcpy(str2,str1+i);
                break;
            }
        }
        for(i=0;str1[i]!='\0';i++)
        {
            if(str1[i]==' ')
            {
                str1[i]='\0';
                break;
            }
        }
        a=tree_add(str1);
        b=tree_add(str2);
        du[a]++;
        du[b]++;
       // printf("a = %d b = %d \n",a,b);
        int x=find(a);
        int y=find(b);
        if(x!=y)
        {
            father[x]=y;
        }
    }
    int aaa=0;
    for(i=1;i<=ids-1;i++)
    {
        if(father[i]==i)
        {
            aaa++;
        }
        if(aaa>1)
        {
            printf("Impossible\n");
            return 0;
        }
    }
    aaa=0;
    for(i=1;i<=ids-1;i++)
    {
        if(du[i]%2==1)
        {
            aaa++;
        }
    }
  //  printf("%d \n",aaa);
    if(aaa>2||aaa==1)
    {
        printf("Impossible\n");
    }
    else
    {
        printf("Possible\n");
    }
    return 0;
}

poj 2513 Colored Sticks 并查集 字典树 欧拉回路判断

时间: 2024-10-19 17:41:09

poj 2513 Colored Sticks 并查集 字典树 欧拉回路判断的相关文章

POJ - Colored Sticks - 并查集+字典树

这道题主要还是要判断是不是欧拉图 说白了就是能不能这幅图能不能用一笔画下来,那么就可以知道了,如果是一个环状的,说明奇数度就不存在,否则就只能用两个奇数度(起点终点)//我的理解这是 只需要用字典树将单词变为对应的一个数字,然后并查集操作就可以,需要维护一个度变量 #include<stdio.h> #include<string.h> int du[500010],p[500010]; int tot=1; struct tree { tree *next[30]; int id

测试赛A - Colored Sticks(并查集+字典树+欧拉回路)

A - Colored Sticks Time Limit:5000MS     Memory Limit:128000KB     64bit IO Format:%I64d & %I64u Submit Status Description You are given a bunch of wooden sticks. Each endpoint of each stick is colored with some color. Is it possible to align the sti

poj 2513 Colored Sticks(欧拉通路+并查集+字典树)

题目链接:poj 2513 Colored Sticks 题目大意:有N个木棍,每根木棍两端被涂上颜色,现在给定每个木棍两端的颜色,不同木棍之间拼接需要颜色相同的 端才可以,问最后能否将N个木棍拼接在一起. 解题思路:欧拉通路+并查集+字典树.欧拉通路,每个节点的统计度,度为奇数的点不能超过2个.并查集,判断节点 是否完全联通.字典树,映射颜色. #include <cstdio> #include <cstring> #include <string> #includ

POJ 2513 Colored Sticks(欧拉回路,字典树,并查集)

题意:给定一些木棒,木棒两端都涂上颜色,求是否能将木棒首尾相接,连成一条直线,要求不同木棒相接的一边必须是相同颜色的. 转:kuangbing 无向图存在欧拉路的充要条件为: ①     图是连通的: ②     所有节点的度为偶数,或者有且只有两个度为奇数的节点. 图的连通可以利用并查集去判断. 度数的统计比较容易. view code//第一次用指针写trie,本来是用二维数组,发现数组开不下,只好删删改改,改成指针 //做这道题,知道了欧拉回路判定,还有用指针写trie #include

POJ 2513 Colored Sticks(字典树+并查集连通性+欧拉回路)

题目地址:POJ 2513 刚开始没想到字典树,用的map函数一直TLE,由于上一次的签到题由于没想到字典树而卡了好长时间的深刻教训,于是过了不久就想起来用字典树了,(为什么是在TLE了5次之后..T^T)然后把map改成了字典树,然后就过了. 这题居然不知不觉的用上了欧拉回路..其实当时我是这样想的..因为相互接触的必须要相同,所以除了两端外,其他的都是两两相同的,所以除了两端的颜色外其他的的个数必须为偶数.然后两端的可能相同可能不相同,相同的话,说明所有的都是偶数个数了,不相同的话那就只有这

[ACM] POJ 2513 Colored Sticks (Trie树,欧拉通路,并查集)

Colored Sticks Time Limit: 5000MS   Memory Limit: 128000K Total Submissions: 29736   Accepted: 7843 Description You are given a bunch of wooden sticks. Each endpoint of each stick is colored with some color. Is it possible to align the sticks in a st

poj 2513 Colored Sticks(欧拉路径+并检查集合+特里)

题目链接:poj 2513 Colored Sticks 题目大意:有N个木棍,每根木棍两端被涂上颜色.如今给定每一个木棍两端的颜色.不同木棍之间拼接须要颜色同样的 端才干够.问最后是否能将N个木棍拼接在一起. 解题思路:欧拉通路+并查集+字典树. 欧拉通路,每一个节点的统计度,度为奇数的点不能超过2个.并查集,推断节点 是否全然联通. 字典树,映射颜色. #include <cstdio> #include <cstring> #include <string> #i

poj 2513 Colored Sticks 彩色棒

poj  2513  Colored Sticks http://poj.org/problem?id=2513 题意:现在有几个木棒,每个木棒端点都着色,问:能否将它们排成一排,同时要满足相邻的的两端点颜色是一样的. trie+并查集+欧拉通路 方法:要想排成一排,可以变向的理解为从一个图里找到一个欧拉通路(一定要想到):如果只是孤零零的一个个小棒,这道题很难实现. 首先:要先要对所有颜色进行编号,由于事先又不知道有几种颜色,有哪几种颜色.故有一个笨方法,用map<int,string>容器

hdu 3172 Virtual Friends (并查集 + 字典树)

题目: 链接:点击打开链接 题意: 输入n,给出n行数据,每行有两个字符串,输出关系网络中朋友的个数,n行. 思路: 代码: #include <iostream> #include <cstdio> #include <cstdlib> #include <cstring> using namespace std; const int N = 22; const int M = 200020; struct node { int c; node *chil